package org.dromara.web.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.web.domain.SysDevice;
import org.dromara.web.domain.bo.SysDeviceBo;
import org.dromara.web.domain.vo.SysDeviceVo;
import org.dromara.web.mapper.SysDeviceMapper;
import org.dromara.web.service.ISysDeviceService;
import org.springframework.stereotype.Service;


import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 设备管理Service业务层处理
 *
 * @author Lion Li
 * @date 2025-08-15
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class SysDeviceServiceImpl implements ISysDeviceService {

    private final SysDeviceMapper baseMapper;

    /**
     * 查询设备管理
     *
     * @param id 主键
     * @return 设备管理
     */
    @Override
    public SysDeviceVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询设备管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 设备管理分页列表
     */
    @Override
    public TableDataInfo<SysDeviceVo> queryPageList(SysDeviceBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SysDevice> lqw = buildQueryWrapper(bo);
        Page<SysDeviceVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的设备管理列表
     *
     * @param bo 查询条件
     * @return 设备管理列表
     */
    @Override
    public List<SysDeviceVo> queryList(SysDeviceBo bo) {
        LambdaQueryWrapper<SysDevice> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SysDevice> buildQueryWrapper(SysDeviceBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SysDevice> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(SysDevice::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getDeviceType()), SysDevice::getDeviceType, bo.getDeviceType());
        lqw.eq(StringUtils.isNotBlank(bo.getDeviceCode()), SysDevice::getDeviceCode, bo.getDeviceCode());
        return lqw;
    }

    /**
     * 新增设备管理
     *
     * @param bo 设备管理
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SysDeviceBo bo) {
        SysDevice add = MapstructUtils.convert(bo, SysDevice.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改设备管理
     *
     * @param bo 设备管理
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SysDeviceBo bo) {
        SysDevice update = MapstructUtils.convert(bo, SysDevice.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SysDevice entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除设备管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
